/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.api.result;

import fr.cenra.rhomeo.api.data.TrackingPoint;
import java.util.Objects;
import org.apache.sis.util.ArgumentChecks;

/**
 * Holds a value for a specific indicator, at a given tracking point.
 * 
 * @param <V> The type of the {@link Index} value.
 * @author Alexis Manin (Geomatys)
 */
public class DefaultTrackingPointIndex<V extends Number> implements TrackingPointIndex<V> {

    private final V value;
    private final TrackingPoint location;
    private final IndexSpi spi;

    public DefaultTrackingPointIndex(final V value, final TrackingPoint location, final IndexSpi spi) {
        ArgumentChecks.ensureNonNull("Value", value);
        ArgumentChecks.ensureNonNull("Tracking point", location);
        ArgumentChecks.ensureNonNull("Index spi", spi);
        this.value = value;
        this.location = location;
        this.spi = spi;
    }

    @Override
    public V getValue() {
        return value;
    }

    @Override
    public int getYear() {
        return location.getYear();
    }

    @Override
    public IndexSpi getSpi() {
        return spi;
    }

    @Override
    public TrackingPoint getPoint() {
        return location;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 47 * hash + Objects.hashCode(this.value);
        hash = 47 * hash + Objects.hashCode(this.location);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (!TrackingPointIndex.class.isAssignableFrom(obj.getClass()))
            return false;

        final TrackingPointIndex other = (TrackingPointIndex) obj;
        return Objects.equals(this.value, other.getValue())
                && Objects.equals(this.location, other.getPoint());
    }
}
